#!/bin/bash
# Name: Steffen Wirth
# Homepage: http://www.pissflitsche.net/kernelscript
# Datum: 03.04.2005
trap "" 2 3
trap "" SIGTSTP
clear
if [ `id -un` != root ] 
	then 
		echo "Please start the script as root"
		exit 0
fi
rm -rf ~/.kernelscript/ 2> /dev/null
mkdir ~/.kernelscript/ 2> /dev/null
cd ~/.kernelscript/ && wget http://www.kernel.org/kdist/finger_banner 2> /dev/null
rm -rf ./stable26 stable24 2> 7dev/null
cat finger_banner | grep "The latest stable version of the Linux kernel is" | cut -b 61-66 >> stable26
cat finger_banner | grep "The latest 2.4 version of the Linux kernel is:" | cut -b 61-66 >> stable24
unset stable26
unset stable24
stable26=`cat stable26`
stable24=`cat stable24`
clear
echo "|------------Welcome to kernelscript 0.3.6-----------|"
echo "|                                                    |"
echo "|            ---Please select a Kernel---            |"
echo "|                                                    |"
echo "|  (1) Kernel $stable26      -- newconfig          (1)  |"
echo "|  (2) Kernel $stable26	   -- oldconfig          (2)  |"
echo "|  (3) Kernel $stable24                            (3)  |"
echo "|  (4) Cancel                                   (4)  |"
echo "|----------------------------------------------------|"
echo "|         - Choose a number and press Enter -        |"
echo -n "|----------------------------------------------------"
read kernel
case "$kernel" in
'1')
	clear
	mkdir /usr/src 2> /dev/null
	rm /usr/src/linux-$stable26.tar.gz & 2> /dev/null
	rm -rf /usr/src/linux-$stable26/ & 2> /dev/null
	cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$stable26.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$stable26.tar.gz
	clear
	echo "Kernel becomes now unpacked!"
	tar -xvzf linux-$stable26.tar.gz && rm ./linux
	ln -s /usr/src/linux-$stable26 /usr/src/linux
	cd /usr/src/linux/ && make menuconfig
	make all && make modules_install || echo "compile error"
	cp ./System.map /boot/System.map-$stable26 &
	cp ./arch/i386/boot/bzImage /boot/vmlinuz-$stable26 &
	mkinitrd /boot/initrd-$stable26 $stable26 || mkinitrd || mk_initrd
	clear
	echo "|---------------------FINAL--------------------|"
	echo "|                                              |"
	echo "| Kernel: /boot/vmlinuz-$stable26                 |"
	echo "| System: /boot/System.map-$stable26              |"
	echo "|----------------------------------------------|"
	echo "|    Inser your new kernel in a Bootloader     |"
	echo "|      GRUB or LILO is the best choice         |"
	echo "|----------------------------------------------|"
	exit
	;;

'2')
	clear	
	rm -rf /usr/src/linux-$stable26.tar.gz & 2> /dev/null
	rm -rf /usr/src/linux-$stable26/ & 2> /dev/null
	cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$stable26.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$stable26.tar.gz
	clear
	tar -xvzf linux-$stable26.tar.gz && rm -rf ./linux
	ln -s ./linux-$stable26 ./linux
	cd /usr/src/linux && zcat /proc/config.gz > .config
	make all && make modules_install || echo " compile error"
	rm -rf /boot/System.map-$stable26 &
	rm -rf /boot/vmlinuz-$stable26 &
	cp ./System.map /boot/System.map-$stable26 &
	cp ./arch/i386/boot/bzImage /boot/vmlinuz-$stable26 &
	mkinitrd /boot/initrd-$stable26 $stable26 || mkinitrd || mk_initrd

	clear
	echo "|---------------------FINAL--------------------|"
	echo "|                                              |"
	echo "| Kernel: /boot/vmlinuz-$stable26                 |"
	echo "| System: /boot/System.map-$stable26              |"
	echo "|----------------------------------------------|"
	echo "|    Inser your new kernel in a Bootloader     |"
	echo "|      GRUB or LILO is the best choice         |"
	echo "|----------------------------------------------|"
	exit
	;;

'3')

	clear
	mkdir /usr/src 2> /dev/null
	rm /usr/src/linux-$stable24.tar.gz & 2> /dev/null
	rm -rf /usr/src/linux-$stable24/ & 2> /dev/null
	cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-$stable24.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-$stable24.tar.gz
	clear
	echo "Kernel becomes now unpacked!"
	tar -xzf linux-$stable24.tar.gz && rm ./linux
	ln -s ./linux-$stable24 ./linux
	cd /usr/src/linux/ && make menuconfig
	make dep clean bzImage || echo "kernel compile error"
	make modules || echo "module compile error"
	make modules_install || echo "modules_install error"
	rm -rf /boot/System.map-$stable24 & 2> /dev/null
	rm -rf /boot/vmlinuz-$stable24 & 2> /dev/null
	cp ./System.map /boot/System.map-$stable24 &
	cp ./arch/i386/boot/bzImage /boot/vmlinuz-$stable24 &
	mkinitrd /boot/initrd-$stable24 $stable24 || mkinitrd || mk_initrd

	clear
	echo "|---------------------FINAL--------------------|"
	echo "|                                              |"
	echo "| Kernel: /boot/vmlinuz-$stable24                 |"
	echo "| System: /boot/System.map-$stable24              |"
	echo "|----------------------------------------------|"
	echo "|    Inser your new kernel in a Bootloader     |"
	echo "|      GRUB or LILO is the best choice         |"
	echo "|----------------------------------------------|"
	exit
	;;
'4')
	exit 0
	;;
'-v')
	clear
	echo "kernelscript Version 0.3.6"
	echo "by bert2002 @ www.pissflitsche.net/kernelscript"
	;;
'--version')	
	clear
	echo "kernelscript Version 0.3.6"
	echo "by bert2002 @ www.pissflitsche.net/kernelscript"
	;;

*)
	
	echo "Please restart script and choose 1 - 2 - 3 or 4 "
esac